// using System.Reflection;
// using cuqmbr.TravelGuide.Domain.Enums;
using cuqmbr.TravelGuide.Domain.Entities;
using Microsoft.EntityFrameworkCore;
// using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

namespace cuqmbr.TravelGuide.Persistence.InMemory;

public class InMemoryDbContext : DbContext
{
    public InMemoryDbContext(DbContextOptions<InMemoryDbContext> options)
        : base(options) { }

    public DbSet<Country> Countries { get => Set<Country>(); }
    public DbSet<Region> Regions { get => Set<Region>(); }
    public DbSet<City> Cities { get => Set<City>(); }
    public DbSet<Address> Addresses { get => Set<Address>(); }

    protected override void OnModelCreating(ModelBuilder builder)
    {
        base.OnModelCreating(builder);

        // builder.HasPostgresEnum(
        //     "vehicle_type",
        //     VehicleType.Enumerations.Select(e => e.Value.Name).ToArray());
        //
    }

    protected override void ConfigureConventions(
        ModelConfigurationBuilder builder)
    {
        // builder
        //     .Properties<VehicleType>()
        //     .HaveColumnType("vehicle_type")
        //     .HaveConversion<VehicleTypeConverter>();
    }
}

// public class VehicleTypeConverter : ValueConverter<VehicleType, string>
// {
//     public VehicleTypeConverter() 
//         : base(
//         v => v.Name,
//         v => VehicleType.FromName(v))
//     { }
// }
